'
'      Graphic temperature display
'
'       PIC 16F628
'
'  r.2   16/05/08
'
   DEFINE OSC 4            'internal oscillator     
'
   DEFINE INTHAND Myint   'define interrupt handler
'
 @ DEVICE PIC16F628,INTRC_OSC,WDT_ON,MCLR_OFF,BOD_Off,LVP_OFF,PROTECT_OFF
'
'
AveTEMPL    var   word $79              'average temperature accumulator low
AveTEMPH    var   word $7B              ' "                              high
Wsave       var   byte $7D  SYSTEM      'uso interrupt  sono visibili sempre
Ssave       var   byte $7E  SYSTEM      'nei 3 banchi
Psave       var   byte $7F  SYSTEM      'fino a 7F
'
TmpW        var   word
TEMPnow     var   Word           'temperatura attuale disponibile
'
Kdiv        var   word           'coefficiente divisione calcolo scala
BotSkal     var   word           'bottom scala display
TopSkal     var   word           'top scala display
'
Clk1        var   byte           'orologio int. timer1 32Hz
Secondi     var   byte           'orologio sequenziatore secondi
Sa_rate     var   byte           'sampling rate counter
'
Tmp1        var   byte       'temporanee
Tmp2        var   byte
Tmp3        var   byte
Sbr1        var   byte      
Sbr2        var   byte
'
'riservate gestione display
Nk_ris      var   byte        'riservato display
Pixpntr     var   byte        'index scrittura array PlotPix immagine punti    
Pixcntr     var   byte        'index lettura array display
X           var   byte        'posizione x display
Y           var   byte        'posizione y display
TmpY        var   byte        'copia y
Pix_pre     var   byte        'posizione Y precedente
Char        var   byte        ' 
Dato        var   byte        'dato al command/data register
'
Flag_V      var   byte        'flag vari
Fl_int      var Flag_V.0      'settato ogni int. Timer1
Fl_Updt     var Flag_V.1      'aggiorna grafico
Fl_Sec      var Flag_V.2      'settato ogni secondo               
Segno       var Flag_V.3      '
Fl_Err      var Flag_V.4      'Error
'           var Flag_V.5      '
'           var Flag_V.6      '
'           var Flag_V.7      '
'
Colonna     var   byte[5]           'colonna grafica display
PlotPix     var   byte[60] bank1    'copia immagine punti grafico
'
'
'   
Dq_DIR      var  TrisA.1    'DS18b20 data direct pin
'      Port  pin number & direction
'            var  PortA.7   'pin 16 I/O                    
'            var  PortA.6   'pin 15 Output                 
'            var  PortA.5   'pin 4  Input                                
Nk_res      var  PortA.4   'pin 3   Output   reset display
Mosi        var  PortA.3   'pin 2   Output   master data out        
Spick       var  PortA.2   'pin 1   Output   Spi clock
Dq          var  PortA.1   'pin 18  I/O      DQ DS18b20    
'            var  PortA.0   'pin 17  Output
'                                                        
'osc         var  PortB.7   'pin 13 Input
'osc         var  PortB.6   'pin 12 Input                 
LedE        var  PortB.5   'pin 11  Output   led Error
LedA        var  PortB.4   'pin 10  Output   led Acquire DS18b20
Cs          var  PortB.3   'pin 9   Output   cs display  
'Tx          var  PortB.2   'pin 8  Output   huart
'Rx          var  PortB.1   'pin 7  Output   huart
C_D         var  PortB.0   'pin 6   Output   command/data sel. register
'
'
'      COSTANTI
'
'Tmr1load  con   34304  '65536-31250+18  1e6/31250 = 32Hz = 0.03125S.
TimrH    con   $86      'timer1 high byte  aggiustato 
TimrL    con   $00      'timer1 low byte  
Ofst30   con   480      'offset 30 ^C. (30/.0625) 
MaxSkal  con   2064     'Lim. sup = 99 + 30gradi =(99*16)+(30*16) = 2064     
AcqTIME  con   15       'lettura temperatura  15 Sec.
'
'eeprom parametri configurazione 
Srate    con   6        'sample rate 
Risol    con   7        'risoluzione divisioni grafico temperature 
IniskaL  con   8        'temperatura inizio scala Low byte
IniskaH  con   9        'temperatura inizio scala High byte
Contrast con   10       'regolazione contrasto display 
' eeprom font character
FontNum  con   16       'font numeri 0-9
Space    con   66       'spazio
Gradi    con   71       'simbolo gradi
Comma    con   76       'virgola
Sneg     con   81       'segno negativo
Dot      con   86       'punto
CharC    con   91       'carattere C
ClesF    con   96       'simbolo clessidra piena
ClesE    con   101      'simbolo clessidra vuota
Termo    con   106      'simbolo termometro
'
LEDON    con   1
LEDOF    con   0
Cr       con   13
Lf       con   10
'
'
'---------------------
'
        Goto inizio             ' Skip around interrupt handler
'
asm
Myint                           ; 2*int + 2*goto             4
        movwf   Wsave           ; Save the W register        1
        swapf   STATUS, W       ;                            1
        clrf    STATUS          ; Point to bank 0            1
        movwf   Ssave           ; Save the STATUS register   1
        movf    PCLATH, W       ;                            1
        movwf   Psave           ;                            1
; 
        btfss   PIR1,TMR1IF     ;interrupt da Tmr1 ?         2
        goto    Restint         ;no skip
;                  
        bcf     T1CON,0         ;STOP TIMER1                 1
        movlw   _TimrH          ;ricarica timer1             1
        movwf   TMR1H           ;                            1
        movlw   _TimrL          ;                            1
        movwf   TMR1L           ;                            1
        bsf    T1CON,0          ;Restart timer1              1
;                                                 totale    18 
        bcf     PIR1,TMR1IF     ; toglie flag int.      
        bsf    _Fl_int          ; Fl_int = 1
        incf   _Clk1,F          ; clk1 = clk1 + 1
        movlw  33
        subwf  _Clk1,W          ; if clk1 > 32 then
        btfss  STATUS,c
        goto   Restint
        incf   _Secondi,F       ;secondi = secondi + 1
        clrf   _Clk1            ; clk1 = 0
        bsf    _Fl_sec          ; Fl_sec = 1
Restint
        movf   Psave, W
        movwf  PCLATH
        swapf  Ssave, W
        movwf  STATUS
        swapf  Wsave, F
        swapf  Wsave, W
        retfie                  ;riattiva GIE
endasm   
'         
'
'visualizza scala temperature
Make_skala:
            Dato = $20        'orrizontal addressing modo testo
            gosub Wr_cmnd
            gosub  NK_Clear                 
            x = 0 : y = 5             'inizia dal fondo
            gosub go2xy
            read iniSkal,tmpW.byte0    'valore inizio scala temperatura
            read IniskaH,TmpW.byte1   'gestisce numeri negativi
            read risol,tmp2           'valore passo risoluzione            
            tmp3 = 0                  'contatore righe
            repeat
               if tmpW.15 = 1 then            'segno negativo
                  char = sneg
                  TEMPnow = ~TmpW + 1           'complemento 2   
               else
                  char = space            'positivo no segno
                  TEMPnow = TmpW
               endif
               gosub wr_char              'display segno      
               char = TEMPnow.byte0 dig 1
               gosub wr_num               'display  decine
               char = TEMPnow.byte0 dig 0
               gosub wr_num               'display unita
               tmp3 = tmp3 + 1            'sale di una riga
               x = 0 : y = y - 1          'muove dal basso all'alto
               gosub go2xy     
               TmpW = TmpW + Tmp2         'Iniskal + Risol      
           until tmp3 > 4
      return
'
'
'area utilizzata per grafico da 23,1 a 83,5
Plot_assi:
      Y = 1                         'grafico inizia da II riga
      Dato = $22                    'vertical addressing modo graph
      gosub Wr_cmnd
      Colonna[0] = %00000001          ' D0 punto piu alto D7 basso Y = 1
      Colonna[1] = %00000010          '                                2
      Colonna[2] = %00001000          '                                3
      Colonna[3] = %00100000          '                                4
      Colonna[4] = %10000000          '                                5
      X = 20 
      gosub Go2XY                'linea vert. tratteggio
      gosub Col_copy
      X = 21 
      gosub Go2XY                'ripete ancora una volta
      gosub Col_copy
'
      Colonna[0] = 255                 ' Y = 1
      Colonna[1] = 255                 '     2
      Colonna[2] = 255                 '     3
      Colonna[3] = 255                 '     4
      Colonna[4] = 255                 '     5
      X = 22 
      gosub Go2XY                'linea verticale continua
      gosub Col_copy
'
      X = 23 
      repeat
          gosub Clr_colonna
          Tmp1 = X & 3            'tratteggia linea
          if Tmp1 = 2 then
            Colonna[0] = %00000001          ' Y = 1    frame linea tratteggio          
            Colonna[1] = %00000010          '     2
            Colonna[2] = %00001000          '     3
            Colonna[3] = %00100000          '     4
            Colonna[4] = %10000000          '     5
          endif
          gosub Go2XY          'aggiorna posizione orrizzontali
          gosub Col_copy
          X = X + 1
      until X > 83
      return
'
'
Clr_colonna:
     Sbr1 = 0
     repeat
        Colonna[Sbr1] = 0
        Sbr1 = Sbr1 + 1
     until Sbr1 > 4
      return
'
'invia la colonna al display
'il posizionamento x y deve essere gia predisposto  Go2XY
Col_copy:
        Dato = $22                 'vertical addressing modo graph
        gosub Wr_cmnd
        sbr2 = 0
        repeat
           Dato = Colonna[sbr2]
           gosub Wr_dato           
           sbr2 = sbr2 + 1
        until sbr2 > 4
        return
'
' mantiene frame e tratteggio assi x
Keep_Frame:
        gosub Clr_colonna                    'cancella linea
        Sbr1 = X & 3
        if Sbr1 = 2 then
           Colonna[0] = %00000001          ' Y = 1  alto linea 
           Colonna[1] = %00000010          '     2
           Colonna[2] = %00001000          '     3  linee orr. spaziate di
           Colonna[3] = %00100000          '     4  10 pixel
           Colonna[4] = %10000000          '     5   basso linea               
        endif
        return
'
'il primo punto va settato con Pix_On
'la posizione X deve gia essere predisposta
'raccorda il punto precedente al punto attuale y sulla stessa colonna
Join_dot:
         TmpY = Y                       'fa una copia di obiettivo
         if y = pix_pre then pix_on     ' set pixel & RETURN 
'            gosub pix_on                  
'            return
'         endif   
         if y > pix_pre then              'linea in salita
               repeat
                  pix_pre = pix_pre + 1
                  y = pix_pre             'passa parametro
                  gosub pix_on            'accende pixel nella colonna
               until y = tmpy             'fino a raggiungere obiettivo
         else                             'linea in discesa
               repeat
                  pix_pre = pix_pre - 1
                  y = pix_pre
                  gosub pix_on
               until y = tmpy
         endif         
         return
'
'
'Setta il pixel nella colonna in uso alla posizione Y
'eventuali bit gi presenti non vengono alterati
'valori validi di y da 0 a 39
Pix_On:
         Tmp1 = 39 - Y                   'inverte verso 1=basso 40=alto
         Tmp2 = Tmp1 // 8                'localizza bit nel byte
         Tmp1 = Tmp1 >> 3                '/8 localizza array
         Tmp3 = 1                        'posiziona bit da settare
         Tmp3 = Tmp3 << Tmp2             'lo sposta in basso
         tmp2 = Colonna[Tmp1]            'recupera byte alla locazione
         tmp2 = tmp2 | Tmp3              'set pixel
         Colonna[Tmp1] = tmp2            'risalva
         return
'
'trova il punto da mettere sul grafico
'ritorna valori tra 0 e 39
Find_dot:
'controllo limiti display mantiene entro l'area grafica
        tmp1 = 39 
        if TEMPnow > topskal then Puntox
        tmp1 = 0
        if TEMPnow < BotSkal then Puntox
'calcola il valore del punto = (temp attuale - inizio scala) * 10 / kdiv        
        tmpw = (TEMPnow - BotSkal) * 10
        tmp1 = TMPW / Kdiv 
Puntox:            
        plotpix[pixpntr] = tmp1     'salva punto 
        pixpntr = pixpntr + 1
'ATTENZIONE occorre sempre chiamare make_room per mantenere i pointer    
         return
'
'se l'array  completo fa scorrere a Sx i punti
'libera l'ultima posizione e riposiziona il pointer alla fine        
Make_room:             
        if pixpntr > 59 then
           sbr1 = 1                 'rd pointer
           sbr2 = 0                 'wr pointer 
           repeat
               tmp1 = plotpix[sbr1]     'fa spazio per prossimo valore
               plotpix[sbr2] = tmp1     'scarica prima posizione
               sbr1 = sbr1 + 1
               sbr2 = sbr2 + 1
           until sbr1  > 59            'fino alla fine dell'array
           pixpntr = 59                'mantiene poiter a fine array
        endif   
        return
'
'
'LCD Initialize
NK_Init:
            Cs = 1
            Nk_res = 0            'reset active low
            pause 20
            Nk_res = 1
            pause 5
            Dato = $21           'Extended commands
            gosub Wr_cmnd
            read Contrast,dato
'            Dato = $c5           'LCD Vop contrast
            gosub Wr_cmnd
            Dato = $06           'Temp coef
            gosub Wr_cmnd
            Dato = $13           'LCD Bias 1:48
            gosub Wr_cmnd
            Dato = $20           'Standard commands
            gosub Wr_cmnd
            Dato = $0C           'Normal Mode
            gosub Wr_cmnd
'Non spostare da qui
'Clear the LCD Data memory
NK_Clear:
            Dato = 0                       'clr ram dati
            TmpW = 0
            repeat                        ' 6 rows x 84 colums
               gosub Wr_dato
               TmpW = TmpW + 1
            until TmpW > 503
            X = 0 : Y = 0                 'predispone posizioni
'            gosub Go2XY
'            return
'Non spostare da qui
'Set the current position for data (0<= x <= 83,  0<= y <= 5)
Go2XY:
         Dato = X | 128              'x or 128
         gosub Wr_cmnd
         Dato =  Y | 64              'y or 64
'         gosub Wr_cmnd
'         return
'Non spostare da qui
'Dato inviato al command register
Wr_cmnd:
         C_D = 0
         goto Tx_spi
'Dato inviato al data register
Wr_dato:
         C_D = 1
         @ nop
Tx_spi:
        Cs = 0                    'enable display
        Nk_ris = 0                'bit counter
        while nk_ris < 8          'invia 8 bit
            Spick = 0             'clock low
            nk_ris = nk_ris + 1
            Mosi = Dato.7         'uscita  Msb first
            Dato = Dato << 1      'prepara prossimo bit uscita
            Spick = 1             'clock up
        wend
        Spick = 0                 'lascia ck low
        Cs = 1                    'disable
        return
'
'         
'la posizione x y deve gia essere settata
'il numero in Char solo da 0 a 9
Wr_Num:
            Char = (Char & 15) * 5   'numeri 0 - 9
            char = Char + FontNum    'index eeprom font table
'l'ind. del font deve essere in char            
'possibili posizioni x char 0,6,12,18,24,30,36,42,48,54,60,66,72,78
Wr_Char:            
            sbr2 = 0                 'ogni carattere largo 5 pixel
            repeat
                  read char,Dato     'legge da eeprom font
'                  gosub Wr_dato     'stack oweflow ???
'???????      3 livelli di stack utilizzati  
        C_D = 1
        @ nop
        Cs = 0
        Nk_ris = 0                'bit counter
        while nk_ris < 8             'invia 8 bit
            Spick = 0               'clock low
            nk_ris = nk_ris + 1
            Mosi = Dato.7           'uscita  Msb first
            Dato = Dato << 1        'prepara prossimo bit uscita
            Spick = 1               'clock up
        wend
        Spick = 0                'lascia ck low
        Cs = 1                   'disable                  
'??????        
                  sbr2 = sbr2 + 1    'column counter
                  char = char + 1    'index counter
            until sbr2 > 4
            Dato = 0                 'spazio tra caratteri
            goto Wr_dato
'            gosub Wr_dato            
'            return
'
'Invia Sbr1 spazi dalla posizione corrente
Blank_L:
           repeat 
            char = space
            gosub wr_char
            sbr1 = sbr1 - 1
           until sbr1 > 128 
           return
'
'risoluzione DS18b20 12bit pari a 0,0625 gradi
'calcola valore in chiaro con segno della temperatura         
Temp_convert:
       TmpW = TEMPnow - ofst30           'toglie offset      
       If TmpW.15 = 1 Then               'se negativo      
          TmpW = ~TmpW 
          TmpW = TmpW + 1                'complemento a 2
          Segno = 1                      'ricorda segno negativo
       Else 
            Segno = 0   
       EndIf     
       Tmp1 = TmpW >> 4                 'estrae parte intera
       Tmp2 = TmpW & 15                 'estrae parte decimale
       TmpW = Tmp2 * 625                'calcola parte decimale
'ritorna in Tmp1 la parte intera ed in TmpW la parte decimale
       return
'
'Evita lettura DS18b20 durante interrupt 
Syncro:
      Fl_int = 0
      while fl_int = 0
         @ nop
      wend
      return
'
'Controlla parametri scala temperatura
Chk_PAR:
         Fl_err = 0
         read iniskaL,Tmpw.byte0
         read iniskaH,Tmpw.byte1
         tmpw = tmpw << 4              'inizio scala * 16
         BotSkal = tmpw + ofst30       '+ 30 gradi  (30/0,0625)= 30*16
         read risol,tmp1
         kdiv = tmp1 << 4              'risol. * 16
         topskal = tmp1 << 6           'risol. * 4 * 16 = * 64
         topskal = BotSkal + topskal   'top scala
' lim. sup = 99 + 30gradi =(99*16)+(30*16) = 2064       
         if topskal > MaxSkal  then Fl_err = 1    'set errore
         return    	 
'
'       
'======================
'
Inizio:
        TRISB = %11000010        'portB configura direzione  0=out 1=in
        TRISA = %10100010        'portA configura direzione
        PortB = %11111110        'preset uscite
        PortA = %11100010        
        CMCON = 7                'per P16F628
        VRCON = 0                'per P16F628
        INTCON = 0               'spento per adesso
        RCSTA = $90              'Enable serial port & continuous receive
        TXSTA = $24              'Enable transmit, BRGH = 1
        SPBRG = 12               '19200 Baud @ 4MHz, 0,16%
'        SPBRG = 25  ' 9600 Baud @ 4MHz, 0,16%    
        OPTION_REG = %10000111
'timer1 prescale = 1,tosc=off,source=internal,tmr1stop
        T1CON = %00000000    
        pause 100
        gosub Nk_init             'inizializza & clear display
        LedA = ledof
        LedE = ledof        
' chek for presence  DS18b20 
Chk_DS18b: 
      Low Dq            'data pin low to init
      Pauseus 500       'Wait > 480us
      Dq_DIR = 1        'Release data pin
      Pauseus 100       'Wait > 60us
      If Dq = 1 Then    'error flash led
         lede = ledon
         pause 500
         lede = ledof 
         Pause 2000
         goto Chk_Ds18b    'resta in loop
      Endif
      pause 2
      OWout Dq, 1,[$CC,$4E,$7F,$80,$7F]	'set 12bit resolution
' demo plot
      gosub Plot_assi
      pause 100
      x = 23                     'inizio area grafico
      pix_pre = 20 
      repeat
        gosub keep_frame
        y = Tmr0/7
        gosub Join_dot           'unisce punti
        Y = 1
        gosub Go2XY
        gosub col_copy
'        pause 20
        X = X + 1
      until X > 83  
'end demo
      OWout Dq,1,[$CC,$44]     'avvia conversione
      pause 2000                 'tempo display  & conversione temperatura
'         
      Tmp1 = RCREG                 'scarica uart receiver
      Tmp1 = RCREG                 'scarica uart receiver
'
Par_chk:
      gosub chk_par                 'controlla se valori coerenti   
      gosub make_skala              'costriusce scala temperature
      gosub Plot_assi               'plotta grafico vuoto
      if Fl_Err = 1 then
         ledE = ledon
         pause 200
         ledE = ledof
         gosub Nk_clear
         pause 1000
         goto par_chk               'resta in loop
      endif   
      Flag_V = 0        
      Clk1 = 0   
      secondi = 0     
      Pixpntr = 0            
      Pixcntr = 0     
      avetempl = 0
      avetemph = 0
      sa_rate = 0
      OWout Dq,1,[$CC,$BE]                'skip rom search 
      Owin Dq,2,[TmpW.BYTE0,TmpW.BYTE1]   'read temperature      
      TEMPnow = TmpW + Ofst30             'somma offset 30 gradi       
      PIE1.0 = 1                          'abilita int da Timer1
      INTCON = %11000000                  'abilita int. PEIE 
      T1CON.0 = 1                         'start timer1
'      
Acquire_lpp:
      If Fl_sec = 1 Then                    'tic ogni sec    
         Fl_sec = 0
         Dato = $20            'orrizontal  addressing modo testo
         gosub Wr_cmnd
         select case secondi
           case 1                    'display Sample Rate
                x = 24 : y = 0       'posizione testo
                gosub go2xy
                Char = ClesF
                gosub wr_char
'                char = Space
'                gosub wr_char
                read Srate,Tmp1
                sbr1 = 2
                repeat
                  char = tmp1 dig sbr1
                  gosub wr_num
                  sbr1 = sbr1 - 1
                until sbr1 > 128  
                sbr1 = 4
                gosub blank_l
           case 5                    'display S.Rate counter (elapsed time)
                x = 24 : y = 0        'posizione testo
                gosub go2xy
                Char = ClesE
                gosub wr_char
'                char = Space
'                gosub wr_char 
                sbr1 = 2
                repeat
                  char = sa_rate dig sbr1
                  gosub wr_num
                  sbr1 = sbr1 - 1
                until sbr1 > 128
                sbr1 = 4
                gosub blank_l 
           case 9                  'display temperatura reale
                 x = 24 : y = 0        'posizione testo
                 gosub go2xy
                 Char = Termo          'simbolo termometro
                 gosub wr_char
                 gosub temp_convert
                 char = space                    'se positivo blank
                 if segno = 1 then char = sneg   'segno negativo
                 gosub wr_char      
                 char = tmp1 dig 1       'decine temperatura attuale
                 gosub wr_num
                 char = tmp1 dig 0       'unita temperatura attuale
                 gosub wr_num
                 char = comma            
                 gosub wr_char
                 char = tmpw dig 3       'I decimale temperatura attuale
                 gosub wr_num
'                Char = TmpW dig 2           'II decimale temperatura attuale
'                gosub wr_num     
                 char = gradi            
                 gosub wr_char
                 char = Charc            
                 gosub wr_char
'                 sbr1 = 1
'                 gosub blank_l
           case (AcqTIME - 1)             'start conversione  al sec. 14
                 gosub syncro   
'                INTCON.7 = 0                 'disab. int.
                 OWout Dq,1,[$CC,$44]         'avvia nuova conversione
'                INTCON.7 = 1                 'riabilita int              
           case is >= AcqTIME              'read temperature al sec. 15
                 leda = ledon
                 gosub syncro
'                intcon.7 = 0 
                 OWout Dq,1,[$CC,$BE]         'skip rom search 
                 Owin Dq,2,[TmpW.BYTE0,TmpW.BYTE1]   'read temperature
'                INTCON.7 = 1                'enab. int.    
                 TEMPnow = TmpW + Ofst30     'somma offset 30 gradi                   
                 secondi = 0  
                 Sa_rate = Sa_rate + 1      'timer sample rate
                 LedA = LEDOF                   
                 read Srate,Tmp1
                 if Sa_rate > Tmp1 then    'terminato sample rate ?
                    r2 = avetempl      '32bit / 16bit average accumulator/samples
                    r0 = avetemph
      	           tempnow = div32 Tmp1   'calcola average
                    Avetemph = 0
                    avetempl = 0            'clear accumulator
                    sa_rate = 0  
                    Fl_updt = 1             'nuovo dato per grafico                       
                 else
 ASM                 
;_Average                                   ; 32bit + 16bit
                    movf     _TEMPnow,w     ;long add 32bit + 16bit
                    addwf    _AveTEMPL,f    ; AveTEMPL,H + TEMPnow 
                    movf     _TEMPnow+1,w
                    btfsc    status,c
                    incfsz   _TEMPnow+1,w
                    addwf    _AveTEMPL+1,f
                    movlw    0
                    btfsc    status,c
                    movlw    1
                    addwf    _AveTEMPH,f
                    movlw    0
                    btfsc    status,c
                    movlw    1
                    addwf    _AveTEMPH+1,f           
 ENDASM         
                 endif   
           end select          
      endif            
'                  
      If Fl_updt = 1 Then 
          Fl_updt = 0
          gosub Find_dot            'mette un nuovo punto & plot grafico
          x = 23                    'posiz. X inizio grafico
          pixcntr = 0
          gosub keep_frame          'mantiene assi di fondo 
          Y = plotpix[pixcntr]      'recupera punto da mettere sul grafico
          pix_pre = y               'lo conserva come precedente
          gosub pix_on              
          y = 1
          gosub Go2XY               'x e y posiziona ad inizio byte
          gosub col_copy            'traccia grafico
          x = x + 1
          pixcntr = 1
          while pixcntr < pixpntr
                gosub Keep_frame    'mantiene assi di fondo
                y = plotpix[pixcntr]
                gosub Join_dot      'unisce punti
                Y = 1
                gosub Go2XY         'posiziona ad inizio area
                gosub col_copy      'traccia grafico
                pixcntr = pixcntr + 1
                x = x + 1           'per tutte le posizioni di X attive
          wend
          gosub make_room        'mantiene i pointer aggiornati & shift display
      endif
'                      
     GoTo aCquire_lpp
'       
'
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'
   eeprom 0,["05/08"]      '
'
'Sample rate = Srate * 15s.
'Valori validi da 1 (15S.) a 255 (3825S.)
   eeprom Srate,[001]       '6  96*15S.=1440S.=24min.*60dot=1440min.=24h.
'
'Risoluzione divisioni scala temperatura
'Valori validi da 1 a 20 corrispondono da 1C a 20C divisione   
   eeprom Risol,[11]        '7 risoluzione temperatura  (pixel*10)
'
'Inizio scala temperatura N.B.  una Word
'Valori validi da -30 a +(99 - Risol*4) 
'se l'equazione non  rispettata viene generato un errore  
'Valori negativi inseriti in complemento 2
'ex. -27 = $FFD9 , -11 = $FFEF , -5 = $FFFB
'Valori positivi si usa solo low byte high byte deve essere a 00
   eeprom IniSkaL,[$FB]      '8 inizio scala low byte
   eeprom iniSkaH,[$FF]      '9 inizio scala high byte
'
'Regolazione contrasto display
'valori suggeriti $B5 (chiaro) $DF (scuro) ma variano da display a display   
   eeprom contrast,[$c6]    '10 display contrasto
'   
   eeprom 11,["nGn"]    '
'font numeri @41
  eeprom FontNUM,[$3E,$51,$49,$45,$3E]		 '16  0
  eeprom [$00,$42,$7F,$40,$00]		       '21  1
  eeprom [$42,$61,$51,$49,$46]		       '26  2
  eeprom [$21,$41,$45,$4B,$31]		       '31  3
  eeprom [$18,$14,$12,$7F,$10]    	       '36  4
  eeprom [$27,$45,$45,$45,$39]	          '42  5 
  eeprom [$3C,$4A,$49,$49,$30]	          '46  6 
  eeprom [$01,$71,$09,$05,$03]	          '51  7 
  eeprom [$36,$49,$49,$49,$36]	          '56  8 
  eeprom [$06,$49,$49,$49,$3E]	          '61  9 
'
  eeprom space,[$00,$00,$00,$00,$00]		 '66  space        
  eeprom Gradi,[$00,$02,$05,$05,$02]		 '71  
  eeprom comma,[$00,$50,$30,$00,$00]		 '76  , 
  eeprom sneg,[$08,$08,$08,$08,$08]		    '81  - 
  eeprom dot,[$00,$60,$60,$00,$00]		    '86  .
  eeprom CharC,[$3E,$41,$41,$41,$22]		 '91  C 
  eeprom ClesF,[$63,$57,$4F,$57,$63]		 '96  simbolo clessidra piena
  eeprom ClesE,[$63,$75,$79,$75,$63]		 '101 simbolo clessidra vuota
  eeprom Termo,[$30,$7E,$79,$7E,$30] 		 '111 simbolo termometro
'                                          '106
'                                          '116  
'                                          '121
'                                          '126

